/*
 * Author: G. Monz (DK7IO), 2011-08-19
 * This file is distributed without any warranty.
 * */

using System;
using System.Collections.Generic;
using System.Windows.Forms;
using GM.Geodesy;

namespace QthManager
{
	public partial class MainForm
	{
		ContextMenuStrip _saveCsvContextMenu1 = new ContextMenuStrip();
		ContextMenuStrip _saveKmlContextMenu1 = new ContextMenuStrip();

		GeographicalPoint _geographicalPoint1;
		public GeographicalPoint GeographicalPoint1
		{
			get
			{
				return _geographicalPoint1;
			}
			set
			{
				_geographicalPoint1 = value;
			}
		}

		void buttonSaveCsv1_MouseUp(object sender, MouseEventArgs e)
		{
			if (e.Button == MouseButtons.Left)
			{
				ResetState1();

				try
				{
					Application.DoEvents();
					SetBusyCursor();
					SaveCsv(textBoxLocator1.Text, textBoxCurrentLocator1, true);
				}
				catch (Exception ex)
				{
					SetState1(ex);
				}
			}
			else if (e.Button == MouseButtons.Right)
			{
				ResetState1();

				try
				{
					ShowSaveCsvContextMenu(e, buttonSaveCsv1, _saveCsvContextMenu1, textBoxLocator1.Text);
				}
				catch (Exception ex)
				{
					SetState1(ex);
				}
			}
		}

		void SaveCsvContextMenu1_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
		{
			ResetState1();

			try
			{
				_saveCsvContextMenu1.Close(ToolStripDropDownCloseReason.ItemClicked);
				SaveCsvContextMenu_ItemClicked(e, textBoxCurrentLocator1);
			}
			catch (Exception ex)
			{
				SetState1(ex);
			}
		}

		void buttonSaveKml1_MouseUp(object sender, MouseEventArgs e)
		{
			if (e.Button == MouseButtons.Left)
			{
				ResetState1();

				try
				{
					Application.DoEvents();
					SetBusyCursor();
					SaveKml(textBoxLocator1.Text, textBoxCurrentLocator1, true);
				}
				catch (Exception ex)
				{
					SetState1(ex);
				}
			}
			else if (e.Button == MouseButtons.Right)
			{
				ResetState1();

				try
				{
					ShowSaveKmlContextMenu(e, buttonSaveKml1, _saveKmlContextMenu1, textBoxLocator1.Text);
				}
				catch (Exception ex)
				{
					SetState1(ex);
				}
			}
		}

		void SaveKmlContextMenu1_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
		{
			ResetState1();

			try
			{
				_saveKmlContextMenu1.Close(ToolStripDropDownCloseReason.ItemClicked);
				SaveKmlContextMenu_ItemClicked(e, textBoxCurrentLocator1);
			}
			catch (Exception ex)
			{
				SetState1(ex);
			}
		}

		void buttonLocatorEnter1_Click(object sender, EventArgs e)
		{
			ResetState1();

			try
			{
				Locator1Enter(true);
			}
			catch (Exception ex)
			{
				SetState1(ex);
			}
		}

		void textBoxLocator1_TextChanged(object sender, EventArgs e)
		{
			LocatorTextBoxChanged(
				textBoxLocator1.Text, buttonLocatorEnter1,
				buttonSaveKml1, buttonSaveCsv1, buttonWaypoints1
			);
		}

		void linkLabelGeoHack1_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
		{
			try
			{
				if (e.Button == MouseButtons.Left)
				{
					StartProcess(linkLabelGeoHack1.Text);
				}
			}
			catch (Exception ex)
			{
				SetState1(ex);
			}
		}

		void textBoxLocatorState1_DoubleClick(object sender, EventArgs e)
		{
			ShowException(textBoxLocatorState1);
		}

		void buttonLocatorPrecisionEnter1_Click(object sender, EventArgs e)
		{
			ButtonLocatorPrecisionEnter(buttonLocatorPrecisionEnter1, textBoxLocator1);
		}

		void listBoxLocatorPrecisions1_SelectedIndexChanged(object sender, EventArgs e)
		{
			ListBoxLocatorPrecisionsSelectedIndexChanged(listBoxLocatorPrecisions1, buttonLocatorPrecisionEnter1);
		}

		void buttonDEnter1_Click(object sender, EventArgs e)
		{
			if (D1Enter())
			{
				try
				{
					Locator1Enter(false);
				}
				catch (Exception ex)
				{
					SetState1(ex);
				}
			}
		}

		void buttonDMEnter1_Click(object sender, EventArgs e)
		{
			if (DM1Enter())
			{
				try
				{
					Locator1Enter(false);
				}
				catch (Exception ex)
				{
					SetState1(ex);
				}
			}
		}

		void buttonDMSEnter1_Click(object sender, EventArgs e)
		{
			if (DMS1Enter())
			{
				try
				{
					Locator1Enter(false);
				}
				catch (Exception ex)
				{
					SetState1(ex);
				}
			}
		}

		void buttonWaypoints1_Click(object sender, EventArgs e)
		{
			ResetState1();

			try
			{
				GeographicalPoint geographicalPoint = GeographicalPoint1;

				if (geographicalPoint != null)
				{
					SetBusyCursor();

					string name = geographicalPoint.Name;
					{
						SaveWaypoints(
							geographicalPoint, textBoxLocator1.Text,
							textBoxWaypointsAzimuth1, textBoxWaypointsCount1, textBoxWaypointsKm1
						);
					}
					geographicalPoint.Name = name;
				}
				else
				{
					throw new InvalidOperationException("No locator or position applied.");
				}
			}
			catch (Exception ex)
			{
				SetState1(ex);
			}
		}

		void GeographicalPoint1Updated()
		{
			GeographicalPointUpdated(
				GeographicalPoint1,
				textBoxDND1, textBoxDED1,
				textBoxDMND1, textBoxDMNM1, textBoxDMED1, textBoxDMEM1,
				textBoxDMSND1, textBoxDMSNM1, textBoxDMSNS1, textBoxDMSED1, textBoxDMSEM1, textBoxDMSES1
			);

			try
			{
				SetMapProvider(linkLabelGeoHack1, labelGeoHack1, GeographicalPoint1);
			}
			catch (Exception ex)
			{
				SetState1(ex);
			}
		}

		void Locator1Enter(bool handleGeographicalPoint)
		{
			ListBox.ObjectCollection items = listBoxLocatorPrecisions1.Items;
			items.Clear();

			string locator = textBoxLocator1.Text.Trim();

			PositionInRectangle positionInRectangle = GetLocatorPositionInGrid(groupBoxLocatorPositionInGrid1);
			GeographicalPoint1 = new GeographicalPoint(locator, positionInRectangle);

			List<string> maidenheadLocators = GeographicalPoint1.GetMaidenheadLocators(checkBoxSmallLettersForSubsquares.Checked);

			foreach (string maidenheadLocator in maidenheadLocators)
			{
				items.Add(maidenheadLocator);
			}

			listBoxLocatorPrecisions1.SelectedIndex = GetListBoxLocatorPrecisionsIndex(locator);

			if (handleGeographicalPoint)
			{
				GeographicalPoint1Updated();
			}
		}

		bool D1Enter()
		{
			bool result = true;

			ResetGeographicalCoordinates1();
			textBoxDMND1.Text = textBoxDMNM1.Text = textBoxDMED1.Text = textBoxDMEM1.Text = null;
			textBoxDMSND1.Text = textBoxDMSNM1.Text = textBoxDMSNS1.Text = textBoxDMSED1.Text = textBoxDMSEM1.Text = textBoxDMSES1.Text = null;
			ResetState1();

			string latitudeD = Get0Value(textBoxDND1);
			string longitudeD = Get0Value(textBoxDED1);

			try
			{
				double latitude = double.Parse(latitudeD);
				double longitude = double.Parse(longitudeD);

				GeographicalPoint1 = new GeographicalPoint(latitude, longitude);
				GeographicalPoint1Updated();

				//Locator
				{
					string locator = GeographicalPoint1.GetMaidenheadLocator(true, MaidenheadLocator.MaxPrecision);
					textBoxLocator1.Text = locator;
				}
			}
			catch (Exception ex)
			{
				result = false;
				SetState1(ex);
			}

			return result;
		}

		bool DM1Enter()
		{
			bool result = true;

			ResetGeographicalCoordinates1();
			textBoxDND1.Text = textBoxDED1.Text = null;
			textBoxDMSND1.Text = textBoxDMSNM1.Text = textBoxDMSNS1.Text = textBoxDMSED1.Text = textBoxDMSEM1.Text = textBoxDMSES1.Text = null;
			ResetState1();

			string latitudeD = Get0Value(textBoxDMND1);
			string longitudeD = Get0Value(textBoxDMED1);

			string latitudeM = Get0Value(textBoxDMNM1);
			string longitudeM = Get0Value(textBoxDMEM1);

			try
			{
				int latitudeDegrees = int.Parse(latitudeD);
				int longitudeDegrees = int.Parse(longitudeD);

				bool latitudeIsNegative = (latitudeDegrees < 0);
				bool longitudeIsNegative = (longitudeDegrees < 0);

				GeographicalPoint1 = new GeographicalPoint(
					latitudeIsNegative, latitudeDegrees, double.Parse(latitudeM),
					longitudeIsNegative, longitudeDegrees, double.Parse(longitudeM)
				);
				GeographicalPoint1Updated();

				//Locator
				{
					string locator = GeographicalPoint1.GetMaidenheadLocator(true, MaidenheadLocator.MaxPrecision);
					textBoxLocator1.Text = locator;
				}
			}
			catch (Exception ex)
			{
				result = false;
				SetState1(ex);
			}

			return result;
		}

		bool DMS1Enter()
		{
			bool result = true;

			ResetGeographicalCoordinates1();
			textBoxDND1.Text = textBoxDED1.Text = null;
			textBoxDMND1.Text = textBoxDMNM1.Text = textBoxDMED1.Text = textBoxDMEM1.Text = null;
			ResetState1();

			string latitudeD = Get0Value(textBoxDMSND1);
			string longitudeD = Get0Value(textBoxDMSED1);

			string latitudeM = Get0Value(textBoxDMSNM1);
			string longitudeM = Get0Value(textBoxDMSEM1);

			string latitudeS = Get0Value(textBoxDMSNS1);
			string longitudeS = Get0Value(textBoxDMSES1);

			try
			{
				int latitudeDegrees = int.Parse(latitudeD);
				int longitudeDegrees = int.Parse(longitudeD);

				bool latitudeIsNegative = (latitudeDegrees < 0);
				bool longitudeIsNegative = (longitudeDegrees < 0);

				GeographicalPoint1 = new GeographicalPoint(
					latitudeIsNegative, latitudeDegrees, int.Parse(latitudeM), double.Parse(latitudeS),
					longitudeIsNegative, longitudeDegrees, int.Parse(longitudeM), double.Parse(longitudeS)
				);
				GeographicalPoint1Updated();

				//Locator
				{
					string locator = GeographicalPoint1.GetMaidenheadLocator(true, MaidenheadLocator.MaxPrecision);
					textBoxLocator1.Text = locator;
				}
			}
			catch (Exception ex)
			{
				result = false;
				SetState1(ex);
			}

			return result;
		}

		void ResetGeographicalCoordinates1()
		{
			GeographicalPoint1 = null;
			ResetLocator(textBoxLocator1, listBoxLocatorPrecisions1);
		}

		void SetState1(Exception exception)
		{
			SetState(textBoxLocatorState1, exception);
		}

		void ResetState1()
		{
			ResetState(textBoxLocatorState1, linkLabelGeoHack1, labelGeoHack1, textBoxCurrentLocator1);
		}
	}
}