/*
 * Author: G. Monz (DK7IO), 2011-08-19
 * This file is distributed without any warranty.
 * */

using System;
using System.Collections.Generic;
using System.Windows.Forms;
using GM.Geodesy;

namespace QthManager
{
	public partial class MainForm
	{
		ContextMenuStrip _saveCsvContextMenu2 = new ContextMenuStrip();
		ContextMenuStrip _saveKmlContextMenu2 = new ContextMenuStrip();

		GeographicalPoint _geographicalPoint2;
		public GeographicalPoint GeographicalPoint2
		{
			get
			{
				return _geographicalPoint2;
			}
			set
			{
				_geographicalPoint2 = value;
			}
		}

		void buttonSaveCsv2_MouseUp(object sender, MouseEventArgs e)
		{
			if (e.Button == MouseButtons.Left)
			{
				ResetState2();

				try
				{
					Application.DoEvents();
					SetBusyCursor();
					SaveCsv(textBoxLocator2.Text, textBoxCurrentLocator2, true);
				}
				catch (Exception ex)
				{
					SetState2(ex);
				}
			}
			else if (e.Button == MouseButtons.Right)
			{
				ResetState2();

				try
				{
					ShowSaveCsvContextMenu(e, buttonSaveCsv2, _saveCsvContextMenu2, textBoxLocator2.Text);
				}
				catch (Exception ex)
				{
					SetState2(ex);
				}
			}
		}

		void SaveCsvContextMenu2_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
		{
			ResetState2();

			try
			{
				_saveCsvContextMenu2.Close(ToolStripDropDownCloseReason.ItemClicked);
				SaveCsvContextMenu_ItemClicked(e, textBoxCurrentLocator2);
			}
			catch (Exception ex)
			{
				SetState2(ex);
			}
		}

		void buttonSaveKml2_MouseUp(object sender, MouseEventArgs e)
		{
			if (e.Button == MouseButtons.Left)
			{
				ResetState2();

				try
				{
					Application.DoEvents();
					SetBusyCursor();
					SaveKml(textBoxLocator2.Text, textBoxCurrentLocator2, true);
				}
				catch (Exception ex)
				{
					SetState2(ex);
				}
			}
			else if (e.Button == MouseButtons.Right)
			{
				ResetState2();

				try
				{
					ShowSaveKmlContextMenu(e, buttonSaveKml2, _saveKmlContextMenu2, textBoxLocator2.Text);
				}
				catch (Exception ex)
				{
					SetState2(ex);
				}
			}
		}

		void SaveKmlContextMenu2_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
		{
			ResetState2();

			try
			{
				_saveKmlContextMenu2.Close(ToolStripDropDownCloseReason.ItemClicked);
				SaveKmlContextMenu_ItemClicked(e, textBoxCurrentLocator2);
			}
			catch (Exception ex)
			{
				SetState2(ex);
			}
		}

		void buttonLocatorEnter2_Click(object sender, EventArgs e)
		{
			ResetState2();

			try
			{
				Locator2Enter(true);
			}
			catch (Exception ex)
			{
				SetState2(ex);
			}
		}

		void textBoxLocator2_TextChanged(object sender, EventArgs e)
		{
			LocatorTextBoxChanged(
				textBoxLocator2.Text, buttonLocatorEnter2,
				buttonSaveKml2, buttonSaveCsv2, buttonWaypoints2
			);
		}

		void linkLabelGeoHack2_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
		{
			try
			{
				if (e.Button == MouseButtons.Left)
				{
					StartProcess(linkLabelGeoHack2.Text);
				}
			}
			catch (Exception ex)
			{
				SetState2(ex);
			}
		}

		void textBoxLocatorState2_DoubleClick(object sender, EventArgs e)
		{
			ShowException(textBoxLocatorState2);
		}

		void buttonLocatorPrecisionEnter2_Click(object sender, EventArgs e)
		{
			ButtonLocatorPrecisionEnter(buttonLocatorPrecisionEnter2, textBoxLocator2);
		}

		void listBoxLocatorPrecisions2_SelectedIndexChanged(object sender, EventArgs e)
		{
			ListBoxLocatorPrecisionsSelectedIndexChanged(listBoxLocatorPrecisions2, buttonLocatorPrecisionEnter2);
		}

		void buttonDEnter2_Click(object sender, EventArgs e)
		{
			if (D2Enter())
			{
				try
				{
					Locator2Enter(false);
				}
				catch (Exception ex)
				{
					SetState2(ex);
				}
			}
		}

		void buttonDMEnter2_Click(object sender, EventArgs e)
		{
			if (DM2Enter())
			{
				try
				{
					Locator2Enter(false);
				}
				catch (Exception ex)
				{
					SetState2(ex);
				}
			}
		}

		void buttonDMSEnter2_Click(object sender, EventArgs e)
		{
			if (DMS2Enter())
			{
				try
				{
					Locator2Enter(false);
				}
				catch (Exception ex)
				{
					SetState2(ex);
				}
			}
		}

		void buttonWaypoints2_Click(object sender, EventArgs e)
		{
			ResetState2();

			try
			{
				GeographicalPoint geographicalPoint = GeographicalPoint2;

				if (geographicalPoint != null)
				{
					SetBusyCursor();

					string name = geographicalPoint.Name;
					{
						SaveWaypoints(
							geographicalPoint, textBoxLocator2.Text,
							textBoxWaypointsAzimuth2, textBoxWaypointsCount2, textBoxWaypointsKm2
						);
					}
					geographicalPoint.Name = name;
				}
				else
				{
					throw new InvalidOperationException("No locator or position applied.");
				}
			}
			catch (Exception ex)
			{
				SetState2(ex);
			}
		}

		void GeographicalPoint2Updated()
		{
			GeographicalPointUpdated(
				GeographicalPoint2,
				textBoxDND2, textBoxDED2,
				textBoxDMND2, textBoxDMNM2, textBoxDMED2, textBoxDMEM2,
				textBoxDMSND2, textBoxDMSNM2, textBoxDMSNS2, textBoxDMSED2, textBoxDMSEM2, textBoxDMSES2
			);

			try
			{
				SetMapProvider(linkLabelGeoHack2, labelGeoHack2, GeographicalPoint2);
			}
			catch (Exception ex)
			{
				SetState2(ex);
			}
		}

		void Locator2Enter(bool handleGeographicalPoint)
		{
			ListBox.ObjectCollection items = listBoxLocatorPrecisions2.Items;
			items.Clear();

			string locator = textBoxLocator2.Text.Trim();

			PositionInRectangle positionInRectangle = GetLocatorPositionInGrid(groupBoxLocatorPositionInGrid2);
			GeographicalPoint2 = new GeographicalPoint(locator, positionInRectangle);

			List<string> maidenheadLocators = GeographicalPoint2.GetMaidenheadLocators(checkBoxSmallLettersForSubsquares.Checked);

			foreach (string maidenheadLocator in maidenheadLocators)
			{
				items.Add(maidenheadLocator);
			}

			listBoxLocatorPrecisions2.SelectedIndex = GetListBoxLocatorPrecisionsIndex(locator);

			if (handleGeographicalPoint)
			{
				GeographicalPoint2Updated();
			}
		}

		bool D2Enter()
		{
			bool result = true;

			ResetGeographicalCoordinates2();
			textBoxDMND2.Text = textBoxDMNM2.Text = textBoxDMED2.Text = textBoxDMEM2.Text = null;
			textBoxDMSND2.Text = textBoxDMSNM2.Text = textBoxDMSNS2.Text = textBoxDMSED2.Text = textBoxDMSEM2.Text = textBoxDMSES2.Text = null;
			ResetState2();

			string latitudeD = Get0Value(textBoxDND2);
			string longitudeD = Get0Value(textBoxDED2);

			try
			{
				double latitude = double.Parse(latitudeD);
				double longitude = double.Parse(longitudeD);

				GeographicalPoint2 = new GeographicalPoint(latitude, longitude);
				GeographicalPoint2Updated();

				//Locator
				{
					string locator = GeographicalPoint2.GetMaidenheadLocator(true, MaidenheadLocator.MaxPrecision);
					textBoxLocator2.Text = locator;
				}
			}
			catch (Exception ex)
			{
				result = false;
				SetState2(ex);
			}

			return result;
		}

		bool DM2Enter()
		{
			bool result = true;

			ResetGeographicalCoordinates2();
			textBoxDND2.Text = textBoxDED2.Text = null;
			textBoxDMSND2.Text = textBoxDMSNM2.Text = textBoxDMSNS2.Text = textBoxDMSED2.Text = textBoxDMSEM2.Text = textBoxDMSES2.Text = null;
			ResetState2();

			string latitudeD = Get0Value(textBoxDMND2);
			string longitudeD = Get0Value(textBoxDMED2);

			string latitudeM = Get0Value(textBoxDMNM2);
			string longitudeM = Get0Value(textBoxDMEM2);

			try
			{
				int latitudeDegrees = int.Parse(latitudeD);
				int longitudeDegrees = int.Parse(longitudeD);

				bool latitudeIsNegative = (latitudeDegrees < 0);
				bool longitudeIsNegative = (longitudeDegrees < 0);

				GeographicalPoint2 = new GeographicalPoint(
					latitudeIsNegative, latitudeDegrees, double.Parse(latitudeM),
					longitudeIsNegative, longitudeDegrees, double.Parse(longitudeM)
				);
				GeographicalPoint2Updated();

				//Locator
				{
					string locator = GeographicalPoint2.GetMaidenheadLocator(true, MaidenheadLocator.MaxPrecision);
					textBoxLocator2.Text = locator;
				}
			}
			catch (Exception ex)
			{
				result = false;
				SetState2(ex);
			}

			return result;
		}

		bool DMS2Enter()
		{
			bool result = true;

			ResetGeographicalCoordinates2();
			textBoxDND2.Text = textBoxDED2.Text = null;
			textBoxDMND2.Text = textBoxDMNM2.Text = textBoxDMED2.Text = textBoxDMEM2.Text = null;
			ResetState2();

			string latitudeD = Get0Value(textBoxDMSND2);
			string longitudeD = Get0Value(textBoxDMSED2);

			string latitudeM = Get0Value(textBoxDMSNM2);
			string longitudeM = Get0Value(textBoxDMSEM2);

			string latitudeS = Get0Value(textBoxDMSNS2);
			string longitudeS = Get0Value(textBoxDMSES2);

			try
			{
				int latitudeDegrees = int.Parse(latitudeD);
				int longitudeDegrees = int.Parse(longitudeD);

				bool latitudeIsNegative = (latitudeDegrees < 0);
				bool longitudeIsNegative = (longitudeDegrees < 0);

				GeographicalPoint2 = new GeographicalPoint(
					latitudeIsNegative, latitudeDegrees, int.Parse(latitudeM), double.Parse(latitudeS),
					longitudeIsNegative, longitudeDegrees, int.Parse(longitudeM), double.Parse(longitudeS)
				);
				GeographicalPoint2Updated();

				//Locator
				{
					string locator = GeographicalPoint2.GetMaidenheadLocator(true, MaidenheadLocator.MaxPrecision);
					textBoxLocator2.Text = locator;
				}
			}
			catch (Exception ex)
			{
				result = false;
				SetState2(ex);
			}

			return result;
		}

		void ResetGeographicalCoordinates2()
		{
			GeographicalPoint2 = null;
			ResetLocator(textBoxLocator2, listBoxLocatorPrecisions2);
		}

		void SetState2(Exception exception)
		{
			SetState(textBoxLocatorState2, exception);
		}

		void ResetState2()
		{
			ResetState(textBoxLocatorState2, linkLabelGeoHack2, labelGeoHack2, textBoxCurrentLocator2);
		}
	}
}